# Solvers.py -- Pamhyr
# Copyright (C) 2023  INRAE
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

# -*- coding: utf-8 -*-

from PyQt5.QtCore import QCoreApplication

from Solver.GenericSolver import GenericSolver
from Solver.Mage import Mage7, Mage8

_translate = QCoreApplication.translate

solver_long_name = {
    "generic": _translate("Solvers", "Generic"),
    # "mage7": _translate("Solvers", "Mage version 7"),
    "mage8": _translate("Solvers", "Mage version 8"),
}

solver_type_list = {
    "generic": GenericSolver,
    # "mage7": Mage7,
    "mage8": Mage8,
}
